#!/usr/bin/python
# -*- coding: utf-8 -*-

#descriptivo.py Operación descriptivo

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
from rpy import *

nombre="Descriptivo"
tipo="Calculo"

listacosas=["Media","Varianza",u"Desviación","Mediana","Moda","Rango",u"Máximo",u"Mínimo","Percentil","Curtosis",u"Coeficiente de Asimetría"]

def funcion(dato,variable,caso,opciones):  # Cambiar cosa por caso
	diccionario={}
	lista=dato.query(variable,caso)
	if opciones.has_key("Media"):
		diccionario["media"]=r.mean(lista)
	if opciones.has_key("Varianza"):
		diccionario["varianza"]=r.var(lista)
	if opciones.has_key(u"Desviación"):
		diccionario["desviacion"]=r.sd(lista)
	if opciones.has_key("Mediana"):
		diccionario["mediana"]=r.median(lista)
	if opciones.has_key("Moda"):
		diccionario["moda"]="TODO"
	if opciones.has_key("Rango"):
		diccionario["rango"]=r.range(lista)
	if opciones.has_key(u"Máximo"):
		diccionario["maximo"]=r.max(lista)
	if opciones.has_key(u"Mínimo"):
		diccionario["minimo"]=r.min(lista)
	if opciones.has_key("Percentil"):
		diccionario["percentil"]="TODO"
	if opciones.has_key("Curtosis"):
		r.require("e1071")
		diccionario["curtosis"]=r.kurtosis(lista)
	if opciones.has_key(u"Coeficiente de Asimetría"):
		r.require("e1071")
		diccionario["asimetria"]=r.skewness(lista)

	return diccionario

def initresultado(resultado,opciones):
	"""Inicializa al objeto resultado, añadiendole lo que crea conveniente"""
	resultado.addTablaSimple("resultado")
	resultado["resultado"].titulo="Descriptivo"
	lista=[]
	if opciones["caso"]:
		lista.append("Caso")
	for operacion in listacosas:
		if opciones.has_key(operacion):
			lista.append(operacion)
	resultado["resultado"].settitulo(lista)


def interfazresultado(resultado,listaopciones):
	"""Este método dice como introducir los datos en la tabla"""
	lista=[]
	variable=listaopciones[0]
	caso=listaopciones[1]
	if caso:
		lista.append(caso)
	diccionario=listaopciones[2]
	if diccionario.has_key("media"):
		lista.append(diccionario["media"])
	if diccionario.has_key("varianza"):
		lista.append(diccionario["varianza"])
	if diccionario.has_key("desviacion"):
		lista.append(diccionario["desviacion"])
	if diccionario.has_key("mediana"):
		lista.append(diccionario["mediana"])
	if diccionario.has_key("moda"):
		lista.append(diccionario["moda"])
	if diccionario.has_key("rango"):
		lista.append(diccionario["rango"])
	if diccionario.has_key("maximo"):
		lista.append(diccionario["maximo"])
	if diccionario.has_key("minimo"):
		lista.append(diccionario["minimo"])
	if diccionario.has_key("percentil"):
		lista.append(diccionario["percentil"])
	if diccionario.has_key("curtosis"):
		lista.append(diccionario["curtosis"])
	if diccionario.has_key("asimetria"):
		lista.append(diccionario["asimetria"])

	resultado["resultado"].set(variable,lista)

diccionarioopciones={
		"nombre":"Opciones",
		"tipo":"SeleccionMultiple",
		"opciones":["Media","Varianza",u"Desviación","Mediana","Moda","Rango",u"Máximo",u"Mínimo","Curtosis",u"Coeficiente de Asimetría"]}
percentil={"nombre":"Percentil","tipo":"EntradaTexto"}

widget={"tipo":"CalculoSimple","opciones":[diccionarioopciones,percentil]}



